<?php

	/* = DNS prefetching
	----------------------------------------------- */
	function slash_dns_prefetch() {

		$get_urls = slash_admin('dns_prefetch');
		$urls = ( !empty($get_urls) ) ? explode("\n", $get_urls ) : '';

		if( !empty($urls) ) :
			$urls = array_map('esc_url', $urls);
			$output = '';
			foreach ( $urls as $url ) {
				$output .= '<link rel="dns-prefetch" href="' . $url . '" />' . "\n";
			}
			
			echo '<meta http-equiv="x-dns-prefetch-control" content="on">' . "\n" . $output;

		endif;
	}
	add_action('wp_head', 'slash_dns_prefetch', 0);

	/* = Prefetch & Prerender pages
	----------------------------------------------- */
	function slash_prefetch_prerender() {
		global $wp_query;
		$prefetch_next 	= slash_admin('prefetch_next');
		$prerender_next = slash_admin('prerender_next');
		$prefetch_home	= slash_admin('prefetch_home');
		$prerender_home = slash_admin('prerender_home');
		$paged 			= $wp_query->query_vars['paged'];

		if ( is_archive() && ($paged > 1) && ($paged < $wp_query->max_num_pages) ) {
			$prefetch 	= $prefetch_next == 1 ? '<link rel="prefetch" href="' . get_next_posts_page_link() . '">' . "\n" : '';
			$prerender 	= $prerender_next == 1 ? '<link rel="prerender" href="' . get_next_posts_page_link() . '">' . "\n" : '';
		} elseif (is_singular()) {
			$home = get_home_url();
			$prefetch	= $prefetch_home == 1 ? '<link rel="prefetch" href="' . $home . '">' . "\n" : '';
			$prerender 	= $prerender_home == 1 ? '<link rel="prerender" href="' . $home . '">' . "\n" : '';
		} else {
			$prefetch = '';
			$prerender = '';
		}

		if( $prefetch_next == 1 || $prerender_next == 1 || $prefetch_home == 1 || $prerender_home == 1 ) {
			echo $prefetch . $prerender;
		}
	}
	add_action('wp_head', 'slash_prefetch_prerender', 1);
?>